// file: HuffmanTree.java
// author: Bob Muller
// date: no idea
// revised: March 2014
//
// This is an API for an ADT of Huffman Trees. They are used in
// a Huffman coding/decoding project in CS102.  Huffman Trees are
// weighted, full binary trees.  The compareTo function allows them
// to inhabit a priority queue.
//
public interface HuffmanTree {
    public int getWeight();
    public char getSymbol();
    public HuffmanTree getLeft();
    public HuffmanTree getRight();
    public boolean isLeaf();
    public void computeBitCodes(SymbolTable st, Bits bits);
    public String toString();
    public int compareTo(Object o);
}